/*
Egy lgitrsasg az utasok rendelkezsre bocstotta azoknak a fldrajzi pontoknak a magassgait tartalmaz sorozatot, amelyek 
fltt a replgp szll majd Kolozsvr s New York kztt. Az a sorozatnak n darab (3 = n <= 10 000), 30 000-nl szigoran 
kisebb termszetes szm eleme van. A szrazfldnek megfelel pontok magassgai 0-tl klnbznek, mg az cennak megfelel 
pontok magassgai egyenlk 0-val. Szigetnek olyan egyms utni szrazfldnek megfelel pontok sorozatt nevezzk, amely eltt 
s utn vz tallhat.
rjatok programot amely: 
1.	Meghatrozza s kirja a leghosszabb sziget kezdett, valamint a vgt jelz pont sorszmt. Ha tbb megolds ltezik, csak 
egyet kell meghatroznotok. Ha nem ltezik egyetlen sziget sem, akkor kirja "Nem ltezik sziget".
2.	Eldnti, hogy a leghosszabb sziget hegy tpus-e vagy sem s kirja a "Hegy", illetve a "Nem hegy" zenetet. Egy sziget hegy 
tpus, ha a felsznn tallhat magassgok egy adott elemig szigoran nvekv - nem res - sorozatot alkotnak, majd szigoran 
cskkent, amely nem res. 
3.	Eldnti, hogy a szrazfldnek megfelel pontok magassgai pronknt klnbz rtkek vagy sem s kirja a "A magassgok 
klnbzk", illetve a "A magassgok nem klnbzk" zenetet. 
4.	Ha a 3. pontban feltett krdsre a vlasz "nem", meghatrozza s kirja a leggyakoribb magassg rtkt s az elfordulsainak 
szmt. Ha tbb ilyen magassg ltezik, csak egyet kell megadnotok.
1. Plda: ha n = 15 s a = (10, 2, 1, 0, 7, 0, 1, 2, 13, 5, 0, 0, 8, 5, 2), sszesen 2 sziget van, a leghosszabb sziget 
a 7. s 10. sorszm magassgok kztt tallhat. A legnagyobb sziget hegy tpus. 
A magassgok rtkei nem klnbzk, s a leggyakoribb magassg rtke 2, amely 3-szor fordul el.
2. Plda: ha n = 10 s a = (1, 2, 0, 1, 2, 13, 0, 0, 1, 2), egyetlen sziget ltezik, amely a 4. s 6. sorszm pontok kztt 
tallhat s nem hegy tpus. A magassgok rtkei nem klnbzk, az egyik leggyakoribb magassg rtke 1 s 3-szor fordul el.
Megjegyzs: A pldkban, az a sorozatot 1-tl kezdve indexeltk.
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream f("pl1.in");

int const MAXDIM = 1001;
int const MAXDIM2 = 30001;

void beOlvas(int & n, int a[]){
// adatok beolvassa

  	f >> n;
  	for(int i = 1; i <= n; i++)
    	f >> a[i];
}

void kiIr(int & n, int a[]){
// a belvasott adatok kirsa 

  	cout << n << endl;
  	for(int i = 1; i <= n; i++)
    	cout << a[i] << " ";
    cout << endl;
}

void repulesSzimulalasa(int n, int a[], int & szigetekSzama, int & maxKezd, int & maxVeg){
// meghatrozzuk a leghosszabb pozitv szmokbl ll tmbszakaszt
int eleje, vege, i;

	maxKezd = 0;
	maxVeg = 0;	
	szigetekSzama = 0;								// mg nem talltunk egy szigetet sem
	i = 1;
	while((i <= n) && (a[i] > 0)) 					// replnk Eurpa fltt
      	i++;
	while(i <= n){									// ha nem rt vget az utazs
    	while((i <= n) && (a[i] == 0))      		// replnk az cen fltt 
      		i++;
		eleje = i;  								// egy sziget kezdete, ha valban sziget
    	while((i <= n) && (a[i] > 0)) 				// replnk a sziget fltt
      		i++;
		if(i < n){									// ha nem rt vget az utazs, vagyis legutoljra nem Amerika fltt repltnk
			szigetekSzama++;						// n a szigetek szma
			vege = i - 1;							// az aktulis sziget vge
    		//cout << "********" << i << endl;
			if(maxVeg - maxKezd <= vege - eleje){	// aktualizljuk a legnagyobb szigetet
        	//cout << "********" << endl;
				maxKezd = eleje;
        		maxVeg = vege;
    		}
    	}
    }
}

bool hegyTulajdonsag(int eleje, int vege, int a[]){
// vizsgljuk, hogy a sziget "hegy"-tpus-e

bool hegy;
int i = eleje;
	while((i < vege) and (a[i] < a[i+1]))					// verificam daca sirul este crescator
		i++;
	hegy = i < vege;										// daca nu s-a terminat insula 
	if(hegy)
		while((i < vege) and (a[i] > a[i+1]))				// verificam daca sirul este descrescator
			i++;
	hegy = hegy and (i == vege);							// daca avem sir crescator, apoi sir descrescator si
																// s-a terminat insula, avem proprietatea de "munte"
	return hegy;
}

bool kulonbozok_e(int n, int a[]){
// a magassgok klnbzsgnek vizsglata

int i = 1;
bool kulonbozok = true;								// presupunem c altitudinile sunt distincte
	while(kulonbozok && (i < n)){
		while(a[i] == 0)							// ne intereseaz doar altitudinile de pe uscat
			i++;									// deci trecem peste "ocean"
			
		int j = i + 1;								// a i-a altitudine este pe uscat
		while((j <= n) && (a[i] != a[j]))			// ct timp altitudinile difer, avansm
			j++;

		kulonbozok = j > n;							// dac nu am gsit altitudinea a[i], "distincte" va fi true
		i++;										// trecem la urmtoarea altitudine
	}	
	return kulonbozok;
}

void leggyakoribbMagassag(int n, int a[], int & magassag, int & k){
// a leggyakoribb magassg meghatrozsa: ez a "magassag" s k-szor fordul el

int elofordulas[MAXDIM2];
	
	for(int i = 1; i < MAXDIM2; i++)					// initializarea frecventelor
		elofordulas[i] = 0;
	for(int i = 1; i <= n; i++)					// determinarea frecventelor
		elofordulas[a[i]]++;
	int max = 1;								// determinarea altitudinii cu frecventa maxima 
	for(int i = 1; i < MAXDIM2; i++)			// evitam altitudinea 0
		if(elofordulas[i] > elofordulas[max])  
			max = i;
	magassag = max;							// "magassag" contine valoarea altitudinii maxime
	k = elofordulas[max];								// "k" contine numarul de aparitii a altitudinii cu frecventa maxima
}

void kiirEredmeny(int szigetekSzama, int eleje, int vege, bool hegy, bool kulonbozok, int magassag, int k){
// az eredmnyek kirsa

	if(szigetekSzama == 0)
     	cout << "Nincs sziget!" << endl;
  	else{
  		cout << "Szigetek szama: " << szigetekSzama << endl;
     	cout << "A legnagyobb sziget a(z) " << eleje << ". es a(z) " << vege << ". pontok kozott talalhato." << endl;
     	if(hegy)
     		cout << "Hegy." << endl;
		else
			cout << "Nem hegy." << endl;
    }
    if(kulonbozok)
		cout << "A magassagok kulonboznek." << endl;
	else{
		cout << "A magassagok nem kulonboznek." << endl;
		cout << "A leggyakoribb magassag: " << magassag << " es " << k << "-szor fordul elo." << endl;	
	}
}

int main(){

int a[MAXDIM];         				// a magassgok sorozata
int n,               				// a magassgok szma
	szigetekSzama,                  // szigetek szma
	eleje,                   		// a legnagyobb sziget kezdetnek sorszma 
    vege,                        	// a legnagyobb sziget vgnek sorszma
    magassag,						// a leggyakoribb magassag
    k;								// a leggyakoribb magassag elfordulsainak szma

bool hegy, kulonbozok;

  	beOlvas(n, a);
  	kiIr(n, a);

// a legnagyobb sziget megkeresese  	
	repulesSzimulalasa(n, a, szigetekSzama, eleje, vege);
	
// a "hegy" tulajdonsag vizsgalata
	if(szigetekSzama != 0)						// ha van legalabb egy sziget
		hegy = hegyTulajdonsag(eleje, vege, a);

// a magassgok klnbzsgnek vizsglata  
	kulonbozok = kulonbozok_e(n, a);
	if(!kulonbozok)
		leggyakoribbMagassag(n, a, magassag, k);		// a leggyakoribb magassg meghatrozsa		
	kiirEredmeny(szigetekSzama, eleje, vege, hegy, kulonbozok, magassag, k);
}
