/*
Tornyok
*/

#include <iostream>
using namespace std;

int tornyokSzama(int n){
// tornyok száma rekurzívan

    if(n == 1) 
    	return 1;
    return 
    	2 * tornyokSzama(n - 1) + 1;
}

int ermekSzama(int n){
// érmék száma rekurzívan

    if(n == 1) 
    	return 1;
    return 
    	2 * ermekSzama(n - 1) + n;
}

void tornyokRekurziv(int n, int & nrT, int & nrM){
// a két rekurzív függvény meghívása

    nrT = tornyokSzama(n);
    nrM = ermekSzama(n);
}

void tornyok(int n, int & tornyokSzama, int & ermekSzama) {
// iteratív algoritmus (együtt kiszámoljuk a tornyok számát és az érmék számát)
// tornyokSzama(n) = 1 + 2 + 2^2 + ... + 2^(n-1)
// ermekSzama(n) = n + (n-1)*2 + (n-2)*2^2 + ... + 1*2^(n-1)

	ermekSzama = 0;
	tornyokSzama = 0;
	int hatvany = 1;
	for (int inaltime = n; inaltime >= 1; inaltime--){
		tornyokSzama = tornyokSzama + hatvany;	
		ermekSzama = ermekSzama + hatvany * inaltime;
		hatvany = hatvany * 2;
	}
}

void tornyokKeplet(int n, int & tornyokSzama, int & ermekSzama) {
// csak a hatványt számoljuk for ciklussal
// tornyokSzama(n) = 1 + 2 + 2^2 + ... + 2^(n-1) = 2^n -1
// ermekSzama(n) = n + (n-1)*2 + (n-2)*2^2 + ... + 1*2^(n-1)

	int hatvany = 1;
	for (int i = 1; i <= n; i++)
		hatvany = hatvany * 2;
	tornyokSzama = hatvany - 1;
	ermekSzama = hatvany*2 - n - 2;
}

int main(){

	int n, tornyokSzama, ermekSzama;
	cout << "n = "; cin >> n;

	tornyokRekurziv(n, tornyokSzama, ermekSzama);
	cout << endl << "Rekurzivan implementalt algoritmus:" << endl;
	cout << "tornyokSzama = " << tornyokSzama << endl;
	cout << "ermekSzama = " << ermekSzama << endl;

	tornyok(n, tornyokSzama, ermekSzama);
	cout << endl << "Iterativan implementalt algoritmus:" << endl;
	cout << "tornyokSzama = " << tornyokSzama << endl;
	cout << "ermekSzama = " << ermekSzama << endl;

	tornyokKeplet(n, tornyokSzama, ermekSzama);
	cout << endl << "Keplettel implementalt algoritmus:" << endl;
	cout << "tornyokSzama = " << tornyokSzama << endl;
	cout << "ermekSzama = " << ermekSzama << endl;
}