/*
Bűvös
*/
#include <iostream>
using namespace std;

int const maxDim = 10000;

bool buvosSzam(int x, int p, int q){
// a "bűvös" tulajdonság ellenőrzése

	int szamjegyek[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
	int masolat = x;
	while (masolat != 0){	     	// meghatározzuk az x szám számjegyeit a p számrendszerben 
		int szj = masolat % p;  	// szj = az utolsó számjegy a p számrendszerben 
		szamjegyek[szj] = 1;
		masolat = masolat / p;
	}
	masolat = x;
	while (masolat != 0){			// redre x számjegyei a q számrendszerben 
		int szj = masolat % q;
		if (szamjegyek[szj] == 0)	// ha az aktuális számjegy (a q számrendszerben) nem szerepelt a p számrendszerben 
			return false;
		szamjegyek[szj]++;
		masolat = masolat / q;
	}
	for (int i = 0; i < 10; i++){
		if (szamjegyek[i] == 1)		// ha az i számjegy szerepelt a p számrendszerben, de nem szerepel a q számrendszerben
			return false;
	}
	return true;
}

void buvosSzamokSorozata(int p, int q, int n, int &k, int t[]){
// kiválogatjuk a bűvös számokat

	k = 0;
	for (int i = 1; i <= n; i++){
		if (buvosSzam(i, p, q)){
			k++;
			t[k] = i;
		}
	}
}

void kiIr(int n, int x[]){

	for (int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}


int main(){

	int n, p, q;
	cout << "n = ";	cin >> n;	// 500
	cout << "p = "; cin >> p;	// 9
	cout << "q = ";	cin >> q;	// 7

	int t[maxDim];
	int k;
	buvosSzamokSorozata(p, q, n, k, t);
	kiIr(k, t);
}
