/* 
Körkörös palindrom
*/

#include <iostream>
#include <fstream>

using namespace std; 

int const maxDim = 1000;

ifstream fin("pali4.in");

void beOlvas(int & n, int a[]){
// beolvassuk a sorozatot

	fin >> n;
	for(int i = 1; i <= n; i++)
    	fin >> a[i];
}

void kiIr(int n, int a[]){
// kiírjuk a sorozatot

	for(int i = 1; i <= n; i++)
    	cout << a[i] << " ";
  	cout << endl;
}

bool palindrom(int a[], int start, int vege){
// vizsgáljuk, hogy a sorozat [start..vége] tömbszakasza palindrom-e

	int i = start;
	int j = vege;
	// páronként összehasonlítjuk az elemeket (az indexek szimetrikusak a tömbszakasz közepétől tekintve)
	
	while(a[i] == a[j] && i < j){
		i++;
		j--;
	}
	return i >= j;
}

int permutalasokSzama(int n, int a[]){
// meghatározzuk azoknak a körkörös permutálásoknak a számát amelyek az n elemű a sorozatot palindrommá alakítják
// ha a sorozat nem alakítható palindrommá ezekkel a körkörös permutációkkal, -1-et térítünk

	// kétszer egymás után másoljuk a sorozatot 
	for (int i = 1; i <= n; i++)
		a[n + i] = a[i];
	bool megvan = false;
	int i = 0;
	while (!megvan && i <= n){
		// ellenőrizzük, hogy az i. helyen kezdődő és n elemű tömbszakasz palindrom-e
		i++;
		megvan = palindrom(a, i, i + n - 1);
		
	}
	if (megvan)
		return i - 1;
	else
		return -1;
}

void kiIrEredmeny(int sz){

	if (sz >= 0)
		cout << "igen " << sz << endl;
	else
		cout << "nem " << endl;
}

int main(){
	int n;
	int a[maxDim];
	
	beOlvas(n, a);
	kiIr(n, a);
	int permSz = permutalasokSzama(n, a);
	kiIrEredmeny(permSz);
}

