#include <iostream>
#include <fstream>

using namespace std;

const int DIMMAX = 320; 

ifstream fin("kep.in");
ofstream fout("kep.out");

void megforditas(int m, int kep[][DIMMAX]){ 
// felcseréli (M) egy bináris számjegyeket tároló mátrix szmjegyeit (0-ból 1 lesz és fordítva) 

	for(int i = 1; i <= m; i++)
		for(int j = 1; j <= m; j++)
			kep[i][j] = 1 - kep[i][j]; 
} 

void forgatas(int m, int kep[][DIMMAX]){ 
// elforgat egy kétdkepenziós tömböt 90 fokkal (F), az óramutató járásával megegyező irányban 

int masolat[DIMMAX][DIMMAX]; 
	for(int i = 1; i <= m; i++)
		for(int j = 1; j <= m; j++)
			masolat[i][j] = kep[i][j]; 
	for(int i = 1; i <= m; i++)
		for(int j = 1; j <= m; j++)
			kep[j][m - i + 1] = masolat[i][j];
} 

void zoom(int &m, int kep[][DIMMAX]){ 
// növeli a mátrix méretét (Z) 

int ujKep[DIMMAX][DIMMAX]; 
int uj_i = 1; 
int uj_j; 
 
	for(int i = 1; i <= m; i++){ 
		uj_j = 1; 
		for(int j = 1; j <= m; j++){ 
			ujKep[uj_i][uj_j] = kep[i][j]; 
			ujKep[uj_i][uj_j + 1] = kep[i][j]; 
			ujKep[uj_i + 1][uj_j++] = kep[i][j]; 
			ujKep[uj_i + 1][uj_j++] = kep[i][j]; 
		} 
		uj_i += 2; 
	}  
	m *= 2; 
	for(int i = 1; i <= m; i++)
		for(int j = 1; j <= m; j++)
			kep[i][j] = ujKep[i][j]; 
} 
 
void kiIr(int m, int kep[][DIMMAX]){ 
// kiÍr egy mátrixot

	for(int i = 1; i <= m; i++){ 
		for(int j = 1; j <= m; j++) 
			cout << kep[i][j] << " "; 
		cout << endl; 
	} 
} 

void kiIrAtalakitasokat(int &k, char s[]){ 
// beolvassa a kért átalakításokat 

	cout << "k = " << k << endl; 

	for(int i = 1; i <= k; i++) 
		cout << s[i];
	cout << endl; 
} 

void atalakitas(int k, char s[], int &m, int kep[][DIMMAX]){ 
// alkalmaz k atalakítást
	for(int i = 1; i <= k; i++){ 
		if(s[i] == 'M') 
			megforditas(m, kep); 
		if(s[i] == 'F') 
			forgatas(m, kep); 
		if(s[i] == 'Z') 
			zoom(m, kep); 
		kiIr(m, kep);
	} 
} 
 
void beOlvas(int &m, int kep[][DIMMAX]){ 
// beolvas egy mátrixot

	fin >> m; 
	for(int i = 1; i <= m; i++)
		for(int j = 1; j <= m; j++)
			fin >> kep[i][j]; 
} 

void beOlvasAtalakitasokat(int &k, char s[]){ 
// beolvassa a kért átalakításokat 

	fin >> k; 
	for(int i = 1; i <= k; i++) 
		fin >> s[i]; 
}

int main(){ 

int m, k; 
int kep[DIMMAX][DIMMAX]; 
	beOlvas(m, kep); 
	kiIr(m, kep);
 
	char s[5]; 
	beOlvasAtalakitasokat(k, s); 
	kiIrAtalakitasokat(k, s);
	atalakitas(k, s, m, kep); 
	kiIr(m, kep); 
}

