/* 
Erős számok
*/

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 10001;
int const maxCif = 33;

ifstream fin("ex.in");

void beOlvas(int & n, int x[]){

	fin >> n;
	for(int i = 1; i <= n; i++)
		fin >> x[i]; 
}

void kiIr(int n, int x[]){

	cout << "n = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

int erosseg_1(int sz){
// a & (és) bitenkénti operátor alkalmazása: sz = sz & (sz – 1) 
// (lépések száma = ahány 1-es számjegye van az ábrázolásnak)
int	ero = 0;
	do{
		sz &= sz - 1;
		ero++;
	} while(sz);
	return ero;
}

int erosseg_2(int sz){
// a & (és) és a >> (jobbra tolás) bitenkénti operátorok alkalmazása: 
// (lépések száma = ahány számjegye van összesen az ábrázolásnak)
	int ero = 0;
	while(sz > 0){
		if(sz & 1)	// ha az utolsó számjegy 1-es 
			ero++;
		sz >>= 1;	// osztás 2-vel (jobbratolással) 
	}
	return ero;
}

int erosseg_3(int sz){
// osztást alkalmazunk: 
// (lépések száma = ahány számjegye van összesen az ábrázolásnak)
	int ero = 0;
	while(sz > 0){
		if(sz % 2 == 1)	// 2-vel való egész osztás maradéka
			ero++;
		sz /= 2;		// osztás
	}
	return ero;
}

int erok(int n, int x[], int csoportok[][maxDim]){

int ero; 
int csSzama = 0;
	for(int i = 1; i < maxCif; i++)
		csoportok[i][0] = 0;					// a csoportok hosszusagainak inicializálása
	for(int i = 1; i <= n; i++){	
		ero = erosseg_1(x[i]);					// az x[i] elem erőssége
		if(!csoportok[ero][0])					// x[i]-vel új csoport kezdődik
			csSzama++;							// nő a csoportok száma
		csoportok[ero][0]++;					// nő az "ero" indexű sor hossza
		csoportok[ero][csoportok[ero][0]] = x[i];// beszúrjuk x[i]-t az erősségének megfelelő sorba
	}
	return csSzama;
}

void kiIrEredmeny(int csSzama, int csoportok[][maxDim]){

  	cout << "csSzama = " << csSzama << endl;
	for(int i = 1; i < maxCif; i++){
		for(int j = 1; j <= csoportok[i][0]; j++) 
			cout << csoportok[i][j] << " ";
		if(csoportok[i][0] != 0)
			cout << endl;
	}
}

int main(){
int n, csSzama;
int x[maxDim];
int csoportok[maxCif][maxDim];

	beOlvas(n, x);
	cout << "Bemeneti adatok:" << endl;
	kiIr(n, x);

	csSzama = erok(n, x, csoportok);
	kiIrEredmeny(csSzama, csoportok);
}

