/* 
Előszelet
*/

#include <iostream>
#include <fstream>

using namespace std;

ifstream fin("1 pelda.in");


const int maxDim = 100; 
const int maxCif = 10; 

void beolvasSzam(int & sz){ 

	fin >> sz; 
}

void kiIrSzam(int & sz){ 

	cout << "sz = " << sz << endl; 
} 

void beolvasMatrix(int & m, int & n, int A[][maxDim]){ 

	fin >> m >> n; 
	for(int i = 1; i <= m; i++){ 
		for(int j = 1; j <= n; j++) 
			fin >> A[i][j]; 
	} 
} 

void kiIrMatrix(int m, int n, int A[][maxDim]){ 

	cout << "m = " << m << " n = " << n << endl; 
	cout << "A matrix:" << endl;
	for(int i = 1; i <= m; i++){ 
		for(int j = 1; j <= n; j++) 
			cout << A[i][j] << " ";
		cout << endl; 
	} 
} 

void beolvasAdatok(int & sz, int & m, int & n, int A[][maxDim]){ 

	beolvasSzam(sz); 
	beolvasMatrix(m, n, A); 
} 

void kiIrAdatok(int sz, int m, int n, int A[][maxDim]){ 

	kiIrSzam(sz); 
	kiIrMatrix(m, n, A); 
}

int sorsSzamjegy(int x){ 
// az x szám sorsszámjegye

	while(x > 9){ 
		int y = x; 
		int s = 0; 
		while(y > 0){ 
			s += y % 10; 
			y /= 10; 
		} 
		x = s; 
	}
	cout << x << " ";
	return x; 
} 

int maxEloszelet(int sz, int m, int n, int A[][maxDim], int szJegyek[], int & szJegyekSzama){ 
// a legnagyobb előszelet meghatározása 
// a mátrixot egyszer járjuk be és meghatározzuk a mátrix elemeinek megfelelő sorsszámjegyekről, hogy elofordultak-e
// a vizsgált szám számjegyeit megőrizzük egy vektorban 
// bejárjuk ezt a vektort (a nagyobb helyértéktől csökkenő sorrendben) és  
// vizsgáljuk, hogy megjelent-e, mint sorsszámjegy

bool elofordulasok[maxCif]; 
	//int i = 0; 
	for(int i = 0; i < 10; i++) // az előfordulások tömbjének inicializálása  
		elofordulasok[i] = 0; 
	for(int i = 1; i <= m; i++){ 
		for(int j = 1; j <= n; j++){ 
			elofordulasok[sorsSzamjegy(A[i][j])] = 1; // előfordul az A[i][j] elem sorsszámjegye  
		}  
	}

	szJegyekSzama = 0; // az sz szám számjegyeinek száma 
	while(sz > 0){ 
		szJegyekSzama++;
		szJegyek[szJegyekSzama] = sz % 10; // az sz szám számjegyei 
		sz /= 10; 
	} 

	int i = szJegyekSzama; // bejárjuk a számjegyek tömbjét 
	while ((i > 0) && (elofordulasok[szJegyek[i]])) // a sorsszámjegy  = az sz szám aktuális számjegyével 
		i--; 
	return szJegyekSzama - i; 
} 
 
void kiIrEloszelet(int hossz, int szJegyek[], int szJegyekSzama){ 
// kiírjuk a leghosszabb előszeletet 

	if(hossz == 0) 
		cout << "Nincs eloszelet" << endl; 
	else{
		cout << endl << "A leghosszabb eloszelet: ";
		for(int i = 1; (i <= hossz && i <= szJegyekSzama); i++) 
			cout << szJegyek[szJegyekSzama - i + 1]; 
		cout << endl; 
	}
} 

int main(){ 

	int nr, m, n; 
	int A[maxDim][maxDim]; 
	beolvasAdatok(nr, m, n, A); 
	kiIrAdatok(nr, m, n, A); 
	int szJegyek[maxCif]; 
	int szJegyekSzama; 
	cout << "A matrix elemeinek sorsszamjegyei: ";
	int hossz = maxEloszelet(nr, m, n, A, szJegyek, szJegyekSzama); 
	kiIrEloszelet(hossz, szJegyek, szJegyekSzama); 
return 0; 
}
